/*************************************************************************
HPGComm (Unix Version)
**************************************************************************

Copyright 2003 Joshua King, ported from HPGComm for Windows released by
HP and Jean-Pierre Bergamin

This file is part of HPGComm (Unix Version).

HPGComm is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

HPGComm is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HPGComm; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**************************************************************************

Copyright (C) January 2001 by HP and Jean-Pierre Bergamin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
***************************************************************************/


// Serial.h: interface for the CSerial class.
//
//////////////////////////////////////////////////////////////////////

#include "notwindows.h"

#if !defined(AFX_SERIAL_H__429F0FA1_6C66_11D3_82D5_0000B4A265C3__INCLUDED_)
#define AFX_SERIAL_H__429F0FA1_6C66_11D3_82D5_0000B4A265C3__INCLUDED_

#ifndef _NOT_WINDOWS_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#endif // _NOT_WINDOWS_

#include "ProtException.h"




struct comdaemoninfo {
#ifndef _NOT_WINDOWS_
        HANDLE		hComPort;
	HANDLE		hKill;
	HANDLE		hResume;
	HANDLE 		hReceived;
	HWND *		phWnd;
#else
	int		iPortDescriptor;
#endif // _NOT_WINDOWS_
};


class CSerial  
{
public:
	int nTimeout;
#ifndef _NOT_WINDOWS_
	HANDLE hResume;
#endif // _NOT_WINDOWS_
	void UnleashDaemon();
	DWORD InBufferLength();
#ifndef _NOT_WINDOWS_
	HWND hNotificationWnd;
	HWND SetNotificationWindow(HWND hWnd);
#endif // _NOT_WINDOWS_
	bool PortIsOpen();
	void FlushComPort(bool bFlushRecvBuffer = true);
	bool ReadCharFromCom(char * ch);
	bool ComActivity();
	void KillComDaemon();
#ifndef _NOT_WINDOWS_
	HANDLE CreateComDaemon(HWND hWnd);
#else
	int CreateComDaemon();
#endif // _NOT_WINDOWS_
	void ClosePort();
	DWORD ReadBufferFromCom(char * buf, DWORD dwBufLen);
	bool WriteBufferToCom(char * buf, DWORD dwBufLen);
	void SetTimeout(int x);
#ifndef _NOT_WINDOWS_
	void OpenPort(int nComPort);
#else
	void OpenPort(string sComPort);
#endif // _NOT_WINDOWS_
	CSerial();
	virtual ~CSerial();
#ifndef _NOT_WINDOWS_
	HANDLE hComPort;
#else
	int hComPort;
	termios sOldPortOptions;
#endif // _NOT_WINDOWS_
	unsigned long m_ulBytesSent;
private:
	static UINT ComDaemon(LPVOID lParam);
#ifndef _NOT_WINDOWS_
	HANDLE hKill;
	DWORD evMask;
	//OVERLAPPED osComDaemon;
	CWinThread * pThread;
#endif // _NOT_WINDOWS_
	comdaemoninfo * daemoninfo;
protected:
	void SendChar(char ch);
#ifndef _NOT_WINDOWS_
	HANDLE hReceived;
#endif // _NOT_WINDOWS_
	void ThrowProtException(CProtException::ERRCODE errcode, DWORD dwSysErrcode = 0, CString sMsg = "");
	void ThrowProtException(CProtException * pEx);
};

#endif // !defined(AFX_SERIAL_H__429F0FA1_6C66_11D3_82D5_0000B4A265C3__INCLUDED_)
