/*************************************************************************
HPGComm (Unix Version)
**************************************************************************

Copyright 2003 Joshua King, ported from HPGComm for Windows released by
HP and Jean-Pierre Bergamin

This file is part of HPGComm (Unix Version).

HPGComm is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

HPGComm is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with HPGComm; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**************************************************************************

Copyright (C) January 2001 by HP and Jean-Pierre Bergamin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
***************************************************************************/

// XModem.h: interface for the CXModem class.
//
//////////////////////////////////////////////////////////////////////

#include "notwindows.h"

#if !defined(AFX_XMODEM_H__D32149AD_84EC_4F1E_B504_00D7AB49B6C8__INCLUDED_)
#define AFX_XMODEM_H__D32149AD_84EC_4F1E_B504_00D7AB49B6C8__INCLUDED_

#ifndef _NOT_WINDOWS_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#endif // _NOT_WINDOWS_

#include "Prot.h"

class CXModem : public CProt  
{
public:
	void RecvFiles();
	void SendFiles();
	BOOL SendFile();
	void ClientRequest(char cFirstChar, char cSecondChar, CString &sCurPath);
#ifndef _NOT_WINDOWS_
	CXModem(HANDLE hPort = NULL);
#else
	CXModem(int hPort = -1);
#endif // _NOT_WINDOWS_
	virtual ~CXModem();
protected:
	void Reset(bool bCloseInfoDlg = true);
	void Cancel();
	char PADCHAR, SOH, EOT, ACK, NAK, CAN, CRC, STX;
	int m_nBufLen;
	char SendPack[2048];
private:
	void Resend();
	int m_nTries;
	void Nak();
	void Ack();
	WORD CalcHPCRC(char * s);
};

#endif // !defined(AFX_XMODEM_H__D32149AD_84EC_4F1E_B504_00D7AB49B6C8__INCLUDED_)
